[LeetCode] 723. Candy Crush 糖果粉碎
This question is about implementing a basic elimination algorithm for Candy Crush.
Given a 2D integer array board
representing the grid of candy, different positive integers board[i][j]
represent different types of candies. A value of board[i][j] = 0
represents that the cell at position (i, j)
is empty. The given board represents the state of the game following the player's move. Now, you need to restore the board to a stable state by crushing candies according to the following rules:
- If three or more candies of the same type are adjacent vertically or horizontally, "crush" them all at the same time - these positions become empty.
- After crushing all candies simultaneously, if an empty space on the board has candies on top of itself, then these candies will drop until they hit a candy or bottom at the same time. (No new candies will drop outside the top boundary.)
- After the above steps, there may exist more candies that can be crushed. If so, you need to repeat the above steps.
- If there does not exist more candies that can be crushed (ie. the board is stable), then return the current board.
You need to perform the above rules until the board becomes stable, then return the current board.
Example 1:
- Input:
- board =
- [[110,5,112,113,114],[210,211,5,213,214],[310,311,3,313,314],[410,411,412,5,414],[5,1,512,3,3],[610,4,1,613,614],[710,1,2,713,714],[810,1,2,1,1],[1,1,2,2,2],[4,1,4,4,1014]]
- Output:
- [[0,0,0,0,0],[0,0,0,0,0],[0,0,0,0,0],[110,0,0,0,114],[210,0,0,0,214],[310,0,0,113,314],[410,0,0,213,414],[610,211,112,313,614],[710,311,412,613,714],[810,411,512,713,1014]]
- Explanation:
Note:
- The length of
board
will be in the range [3, 50]. - The length of
board[i]
will be in the range [3, 50]. - Each
board[i][j]
will initially start as an integer in the range [1, 2000].
一个类似糖果消消乐游戏的题,给一个二维数组board,数组代表糖果,在水平和竖直方向上3个或以上连续相同的数字可以被消除,消除后位于上方的数字会填充空位。注意是所以能消除的糖果消除后然后再落下,进行第二次消除。直到最后没有能消除的了,达到稳定状态。
解法:标记出所有需要被crush的元素,然后去掉这些元素,将上面的数下降,空位变为0。难的地方是如何确定哪些元素需要被crush。
Python:
- class Solution(object):
- def candyCrush(self, board):
- """
- :type board: List[List[int]]
- :rtype: List[List[int]]
- """
- R, C = len(board), len(board[0])
- changed = True
- while changed:
- changed = False
- for r in xrange(R):
- for c in xrange(C-2):
- if abs(board[r][c]) == abs(board[r][c+1]) == abs(board[r][c+2]) != 0:
- board[r][c] = board[r][c+1] = board[r][c+2] = -abs(board[r][c])
- changed = True
- for r in xrange(R-2):
- for c in xrange(C):
- if abs(board[r][c]) == abs(board[r+1][c]) == abs(board[r+2][c]) != 0:
- board[r][c] = board[r+1][c] = board[r+2][c] = -abs(board[r][c])
- changed = True
- for c in xrange(C):
- i = R-1
- for r in reversed(xrange(R)):
- if board[r][c] > 0:
- board[i][c] = board[r][c]
- i -= 1
- for r in reversed(xrange(i+1)):
- board[r][c] = 0
- return board
C++:
- // Time: O((R * C)^2)
- // Space: O(1)
- class Solution {
- public:
- vector<vector<int>> candyCrush(vector<vector<int>>& board) {
- const auto R = board.size(), C = board[0].size();
- bool changed = true;
- while (changed) {
- changed = false;
- for (int r = 0; r < R; ++r) {
- for (int c = 0; c + 2 < C; ++c) {
- auto v = abs(board[r][c]);
- if (v != 0 && v == abs(board[r][c + 1]) && v == abs(board[r][c + 2])) {
- board[r][c] = board[r][c + 1] = board[r][c + 2] = -v;
- changed = true;
- }
- }
- }
- for (int r = 0; r + 2 < R; ++r) {
- for (int c = 0; c < C; ++c) {
- auto v = abs(board[r][c]);
- if (v != 0 && v == abs(board[r + 1][c]) && v == abs(board[r + 2][c])) {
- board[r][c] = board[r + 1][c] = board[r + 2][c] = -v;
- changed = true;
- }
- }
- }
- for (int c = 0; c < C; ++c) {
- int empty_r = R - 1;
- for (int r = R - 1; r >= 0; --r) {
- if (board[r][c] > 0) {
- board[empty_r--][c] = board[r][c];
- }
- }
- for (int r = empty_r; r >= 0; --r) {
- board[r][c] = 0;
- }
- }
- }
- return board;
- }
- };
C++:
- class Solution {
- public:
- vector<vector<int>> candyCrush(vector<vector<int>>& board) {
- int m = board.size(), n = board[0].size();
- while (true) {
- vector<pair<int, int>> del;
- for (int i = 0; i < m; ++i) {
- for (int j = 0; j < n; ++j) {
- if (board[i][j] == 0) continue;
- int x0 = i, x1 = i, y0 = j, y1 = j;
- while (x0 >= 0 && x0 > i - 3 && board[x0][j] == board[i][j]) --x0;
- while (x1 < m && x1 < i + 3 && board[x1][j] == board[i][j]) ++x1;
- while (y0 >= 0 && y0 > j - 3 && board[i][y0] == board[i][j]) --y0;
- while (y1 < n && y1 < j + 3 && board[i][y1] == board[i][j]) ++y1;
- if (x1 - x0 > 3 || y1 - y0 > 3) del.push_back({i, j});
- }
- }
- if (del.empty()) break;
- for (auto a : del) board[a.first][a.second] = 0;
- for (int j = 0; j < n; ++j) {
- int t = m - 1;
- for (int i = m - 1; i >= 0; --i) {
- if (board[i][j]) swap(board[t--][j], board[i][j]);
- }
- }
- }
- return board;
- }
- };
C++:
- class Solution {
- public:
- vector<vector<int>> candyCrush(vector<vector<int>>& board) {
- int m = board.size(), n = board[0].size();
- bool toBeContinued = false;
- for (int i = 0; i < m; ++i) { // horizontal crushing
- for (int j = 0; j + 2 < n; ++j) {
- int& v1 = board[i][j];
- int& v2 = board[i][j+1];
- int& v3 = board[i][j+2];
- int v0 = std::abs(v1);
- if (v0 && v0 == std::abs(v2) && v0 == std::abs(v3)) {
- v1 = v2 = v3 = - v0;
- toBeContinued = true;
- }
- }
- }
- for (int i = 0; i + 2 < m; ++i) { // vertical crushing
- for (int j = 0; j < n; ++j) {
- int& v1 = board[i][j];
- int& v2 = board[i+1][j];
- int& v3 = board[i+2][j];
- int v0 = std::abs(v1);
- if (v0 && v0 == std::abs(v2) && v0 == std::abs(v3)) {
- v1 = v2 = v3 = -v0;
- toBeContinued = true;
- }
- }
- }
- for (int j = 0; j < n; ++j) { // gravity step
- int dropTo = m - 1;
- for (int i = m - 1; i >= 0; --i) {
- if (board[i][j] >= 0) {
- board[dropTo--][j] = board[i][j];
- }
- }
- for (int i = dropTo; i >= 0; i--) {
- board[i][j] = 0;
- }
- }
- return toBeContinued ? candyCrush(board) : board;
- }
- };
All LeetCode Questions List 题目汇总
[LeetCode] 723. Candy Crush 糖果粉碎的更多相关文章
- [LeetCode] 723. Candy Crush 糖果消消乐
This question is about implementing a basic elimination algorithm for Candy Crush. Given a 2D intege ...
- LeetCode 723. Candy Crush
原题链接在这里:https://leetcode.com/problems/candy-crush/ 题目: This question is about implementing a basic e ...
- [LeetCode] Candy Crush 糖果消消乐
This question is about implementing a basic elimination algorithm for Candy Crush. Given a 2D intege ...
- 【LeetCode】723. Candy Crush 解题报告 (C++)
作者: 负雪明烛 id: fuxuemingzhu 个人博客:http://fuxuemingzhu.cn/ 目录 题目描述 题目大意 解题方法 暴力 日期 题目地址:https://leetcode ...
- [LeetCode] Candy (分糖果),时间复杂度O(n),空间复杂度为O(1),且只需遍历一次的实现
[LeetCode] Candy (分糖果),时间复杂度O(n),空间复杂度为O(1),且只需遍历一次的实现 原题: There are N children standing in a line. ...
- LeetCode:135. 分发糖果
LeetCode:135. 分发糖果 老师想给孩子们分发糖果,有 N 个孩子站成了一条直线,老师会根据每个孩子的表现,预先给他们评分. 你需要按照以下要求,帮助老师给这些孩子分发糖果: 每个孩子至少分 ...
- [LeetCode] Candy 分糖果问题
There are N children standing in a line. Each child is assigned a rating value. You are giving candi ...
- LeetCode OJ:Candy(糖果问题)
There are N children standing in a line. Each child is assigned a rating value. You are giving candi ...
- LeetCode.888-公平的糖果交换(Fair Candy Swap)
这是悦乐书的第339次更新,第363篇原创 01 看题和准备 今天介绍的是LeetCode算法题中Easy级别的第208题(顺位题号是888).Alice和Bob有不同大小的糖果棒:A[i]是Alic ...
随机推荐
- python deque的内在实现 本质上就是双向链表所以用于stack、队列非常方便
How collections.deque works? Cosven 前言:在 Python 生态中,我们经常使用 collections.deque 来实现栈.队列这些只需要进行头尾操作的 ...
- G1垃圾收集器系统化说明【官方解读】
还是继续G1官网解读,上一次已经将这三节的东东读完了,如下: 所以接一来则继续往下读: Reviewing Generational GC and CMS[回顾一下CMS收集器] The Concur ...
- 用python+openpyxl从表格中读取测试用例的多条数据,然后将执行结果写入表格中
# -*- coding: utf-8 -*- from selenium import webdriver from openpyxl import load_workbook class mylo ...
- arduino adc数模放大器
http://ardui.co/archives/833 http://henrysbench.capnfatz.com/henrys-bench/arduino-voltage-measuremen ...
- 2019-2020-1 20199302《Linux内核原理与分析》第十一周作业
缓冲区溢出 缓冲区溢出是指程序试图向缓冲区写入超出预分配固定长度数据的情况.这一漏洞可以被恶意用户利用来改变程序的流控制,甚至执行代码的任意片段.这一漏洞的出现是由于数据缓冲器和返回地址的暂时关闭,溢 ...
- springboot(三)
SpringBoot 整合JdbcTemplate 1.创建一个springboot_jdbc项目 2.导入依赖 <dependency> <groupId>org.spri ...
- ShardingSphere初探1 --Sharding-JDBC
Sharding-JDBC 引入maven依赖: <dependency> <groupId>org.apache.shardingsphere</groupId> ...
- 15-ESP8266 SDK开发基础入门篇--上位机串口控制 Wi-Fi输出PWM的占空比,调节LED亮度,上位机程序编写
https://www.cnblogs.com/yangfengwu/p/11104167.html 先说一下整体思路哈.. 咱滑动的时候 会进入这个,然后咱呢不直接从这个里面写发送 因为这样的话太快 ...
- 洛谷P3534 [POI2012] STU
题目 二分好题 首先用二分找最小的绝对值差,对于每个a[i]都两个方向扫一遍,先都改成差满足的形式,然后再找a[k]等于0的情况,发现如果a[k]要变成0,则从他到左右两个方向上必会有两个连续的区间也 ...
- B. Heaters ( Codeforces Round #515 (Div. 3) )
题解:对于每个点 i 来说,从 j = i + r - 1 开始往前找,如果找到一个 a [ j ] 是 1 ,那么就把它选上,但是我们需要判断交界处,也就是如果前面选的那个可以让这个点变温暖,就不用 ...